=== debian/changelog ===
tiledarray (0.4.4-2) unstable; urgency=medium

  [ Daniel Leidert ]
  * Add debian/watch

  [ Graham Inggs]
  * Fix FTBFS with Boost >= 1.59 (Closes: #835279)
  * Use secure URI for Vcs-Browser
  * Switch from OMPI_MCA_orte_rsh_agent to OMPI_MCA_plm_rsh_agent
  * Bump Standards-Version to 3.9.8, no changes

 -- Graham Inggs <ginggs@debian.org>  Thu, 25 Aug 2016 17:34:10 +0200

tiledarray (0.4.4-1) unstable; urgency=medium

  * Initial upload (Closes: #794695).

 -- Michael Banck <mbanck@debian.org>  Fri, 07 Aug 2015 17:48:34 +0200
